codeforces 689D ST表+二分 模板

Mike and !Mike are old childhood rivals, they are opposite in everything they do, except programming. Today they have a problem they cannot solve on their own, but together (with you) — who knows?

Every one of them has an integer sequences a and b of length n. Being given a query of the form of pair of integers (l, r), Mike can instantly tell the value of while !Mike can instantly tell the value of .

Now suppose a robot (you!) asks them all possible different queries of pairs of integers (l, r) (1 ≤ l ≤ r ≤ n) (so he will make exactly n(n + 1) / 2 queries) and counts how many times their answers coincide, thus for how many pairs is satisfied.

How many occasions will the robot count?

Input
The first line contains only integer n (1 ≤ n ≤ 200 000).

The second line contains n integer numbers a1, a2, …, an ( - 109 ≤ ai ≤ 109) — the sequence a.

The third line contains n integer numbers b1, b2, …, bn ( - 109 ≤ bi ≤ 109) — the sequence b.

Output
Print the only integer number — the number of occasions the robot will count, thus for how many pairs is satisfied.

Example
Input
6
1 2 3 2 1 4
6 7 1 2 3 2
Output
2
Input
3
3 3 3
1 1 1
Output
0
Note
The occasions in the first sample case are:

1.l = 4,r = 4 since max{2} = min{2}.

2.l = 4,r = 5 since max{2, 1} = min{2, 3}.

There are no occasions in the second sample case since Mike will answer 3 to any query pair, but !Mike will always answer 1.

题意:
给定两个等长区间,求相同l,r情况下,有多少个区间,第一个序列的最大值和第二个序列的最小值相同。

因为最大值是一个单调递增的函数,最小值是一个单调递减的函数,所以 i区间到mid区间的 (最大值-最小值) 是一个单调递增的函数。所以枚举左端点,不断的进行二分右端点,分别进行两个二分可以得到两个右端点,第一个右端点,代表的是满足,max(i,mid)==min(i,mid) 的右边界最大值,然后第二个右端点表示的是max(i,mid)==min(i,mid) 的右边界最小值。 两者一减,那么就是左边界为i,右边界在(t1~t2)满足,这些是都满足的区间数。
献上代码很好理解。。

无敌快的代码

#include <bits/stdc++.h>
using namespace std;
int n;
int a[201000],b[201000];
int mn[201000][30];
int mx[201000][30];
int num;
void init()
{
    for(int i=1;i<=n;i++)
    {
        mx[i][0]=a[i],mn[i][0]=b[i];
    }
    for(int j = 1; (1<<j) <= n; ++j)  
        for(int i = 1; i + (1<<j) - 1 <= n; ++i)  
        {  
            mx[i][j] = max(mx[i][j-1],mx[i+(1<<(j-1))][j-1]);  
            mn[i][j] = min(mn[i][j-1],mn[i+(1<<(j-1))][j-1]);  
        }  
}



int rmq(int i,int j,int f)
{
    int k=0;
      while((1 << (k + 1)) <= j - i + 1) k++;  
    int res=0;
    if(f==0)
        res=min(mn[i][k],mn[j-(1<<k)+1][k]);
    if(f==1)
        res=max(mx[i][k],mx[j-(1<<k)+1][k]);
    return res;
}



int main()
{
    scanf("%d",&n);
    for(int i=1;i<=n;i++)
        scanf("%d",&a[i]);
    for(int i=1;i<=n;i++)
        scanf("%d",&b[i]);
    init();
    long long ans=0;
    for(int i=1;i<=n;i++)
    {
        int l=i,r=n;
        int t1=-1,t2=-1;
        while(l<=r)
        {
            int mid=(l+r)>>1;
            int re1=rmq(i,mid,1),re2=rmq(i,mid,0);
            if(re1>re2)
            {
                r=mid-1;
            }
            else if(re1<re2)
            {
                l=mid+1;
            }
            else if(re1==re2){
                t1=mid;
                r=mid-1;
            }
        }
        if(t1==-1) continue;
        l=i,r=n;
        while(l<=r)
        {
            int mid=(l+r)>>1;
            int re1=rmq(i,mid,1),re2=rmq(i,mid,0);
            if(re1>re2)
                r=mid-1;
            else if(re1<re2)
                l=mid+1;
            else 
            {
                t2=mid;
                l=mid+1;
            }
        }
        ans+=t2-t1+1;
    }
    printf("%lld\n",ans );
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个整数k,需要找到一个子段,该子段中不超过k个不同的数字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同数的个数。每次如果这个数小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个数不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种数。使用一个map来判断数的种类。遍历序列,如果当前数字在map中不存在,则将种类数sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.csdn.net/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.csdn.net/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值